[CCode (cheader_filename = "gctwimax.h")]
namespace GctWimax {

	[CCode (cname="gctwimax_wimax_t", cprefix="gctwimax_")]
	public class Wimax {
		public int tap_fd;
		public char[] tap_dev;
		public int error_code;
		public GctWimaxCallback on_device_disconnect_callback;
		public void* user_data_for_callback;
		public Connection connection_status;
		public Device device_info;
		public Config config;
		
		[CCode (cname="gctwimax_wimax_new")]
		public Wimax();
		public static void set_log(int logger, Posix.FILE? logfile = null);
		public static void set_log_full(int verbose, int logger, Posix.FILE? logfile = null);
		public static void set_log_file(Posix.FILE? logfile = null);
		public static void set_log_level(int verbose);
		public static void inc_log_level();
		public int search_network();
		public int connected_to_network();
		public int start_authentication();
		public int keep_connection();
		public int init();
		public int init_tap();
		public int up_tap();
		public int deinit_tap();
		public int down_tap();
		public static unowned string get_version();
		[CCode (cname="gctwimax_wimax_free")]
		public static void free(Wimax* obj);
		public void cb_add_pollfd();
	}
	
	[CCode (cname="gctwimax_connection_t")]
	public struct Connection {
		public int link_status;
		public short rssi1;
		public short rssi2;
		public short cinr1;
		public short cinr2;
		public uchar[] bsid;
		public ushort txpwr;
		public uint freq;
		public uint nspid;
		public int rf_state;
		public int auth_info;
	}
	
	[CCode (cname="gctwimax_device_t")]
	public struct Device {
		public char[] chip;
		public char[] firmware;
		public uchar[] mac;
	}
	
	[CCode (cname="gctwimax_config_t")]
	public struct Config {
		public string eap_login;
		public string eap_pass;
		public string eap_outer_nai;
		public int eap_type;
		public string conf_dir;
	}
	
	[CCode (cname="gctwimax_callback", has_target=false)]
	public delegate void GctWimaxCallback(void* user_data);
}
